﻿/**
* Flickr
* last update 08/25/2004
* <a href="http://anothersite.com">A link</a>
* @see <a href="http://www.flickr.com/services/api/">Flickr API</a>
* @version	1.0
* @author	Fabricio Zuardi
*/;
import com.zuardi.flickr. *;
class com.zuardi.flickr.Flickr
{
	private static var REST_ENDPOINT : String = "http://www.flickr.com/services/rest/";
	public var api_key : String;
	private var _email : String;
	private var _password : String;
	private var _rest_endpoint : String;
	public var blogs : FlickrBlogs;
	public var contacts : FlickrContacts;
	public var people : FlickrPeople;
	public var tags : FlickrTags;
	public var test : FlickrTest;
	public var favorites : FlickrFavorites;
	public var urls : FlickrUrls;
	public var photos : FlickrPhotos;
	/**
	* @param api_key:		(required) The api_key of the application
	* @param user_email:	(optional) The email to use on methods that requires user authentication 
	* @param user_password:	(optional) The email to use on methods that requires user authentication 
	* @see <a href="http://www.flickr.com/services/api/misc.userauth.html">User Authentication Flickr API page</a>
	* @param rest_endpoint:	(optional) The rest endpoint url
	* */
	function Flickr (api_key : String, user_email : String, user_password : String, rest_endpoint : String)
	{
		if ( ! api_key)
		{
			throw new Error ("api_key is required");
		} else
		{
			this.api_key = api_key;
		};
		if ( ! rest_endpoint)
		{
			this._rest_endpoint = REST_ENDPOINT;
		} else
		{
			this._rest_endpoint = rest_endpoint;
		};
		this._email = user_email;
		this._password = user_password;
		this.blogs = new FlickrBlogs (this.api_key, this._email, this._password, this._rest_endpoint);
		this.contacts = new FlickrContacts (this.api_key, this._email, this._password, this._rest_endpoint);
		this.people = new FlickrPeople(this.api_key,this._rest_endpoint)
		this.tags = new FlickrTags(this.api_key,this._rest_endpoint)
		this.test = new FlickrTest(this.api_key,this._rest_endpoint)
		this.favorites = new FlickrFavorites(this.api_key, this._email, this._password, this._rest_endpoint);
		this.urls = new FlickrUrls(this.api_key,this._rest_endpoint)
		this.photos = new FlickrPhotos(this.api_key, this._email, this._password, this._rest_endpoint)
	};
};
